Added mencoder_threads variable for multicore encoding support
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies:
19 # lsdvd dvdauthor gddrescue dvdbackup makexml tovid mencoder vlc mplayer genisoimage
20 #
21 # Optional Dependencies:
22 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
23 #
24
25 ###############################################
26 # Local Machine Settings - EDIT THIS SECTION
27
28 # Specify the device path to the DVD drive
29 dev=/dev/dvd2
30
31 # Specify the path to the log directory 
32 logdir=/var/log/ripdvd
33
34 # Specify the path to the tmp rip directory
35 tmpdir=/myth/video/DVDs/.ripdvd
36
37 # Specify the email address to send job notifications to
38 mailto=ajp@pippins.net
39
40 # Setup the path to the tools needed by this ripper
41 PATH=/etc/mythtv/bin:/usr/local/bin:/usr/sbin:/sbin:/usr/bin:.:$PATH
42
43 # Use mplayer dumpstream to create the main VOB file
44 # If set to 0, cat and other utils will be used to make it instead.
45 # Using mplayer dumpstream is by far the best way to create the main VOB file
46 # The only thing this doesn't work for are DVDs with the 99 title copy protection.
47 # The script will autodetect these types of disks, and change this to 0 if necessary.
48 # If this is set to 0, other methods will be employed to get the DVD VOB dump.
49 use_mplayer_dumpstream=1
50
51 # 2-channel AVI encoding audio bit rate
52 audio_bitrate=224
53
54 # If set to 1, this script will call another script to fill in the mythvideo metadata
55 # If you don't use mythtv, set this option to 0. If you use mythtv, and have downloaded
56 # the fill_mythvideo_metadata.pl script shown above, you can leave this option set to 1.
57 fill_mythvideo_metadata=1
58
59 # If the 99 titleset copy protection scheme is detected, trust the autodetection or abort.
60 # The autodetection may work, but it probably won't in this case. Set to 0 by default. 
61 # Override to 1 if you want the script to wing it, and hope it picks the right feature title.
62 # Otherwise, you will need to rerun the script providing the feature title with the -t option.
63 trust_feature_title_autodetect_when_uncertain=0
64
65 # specify the number of threads that mencoder should use when encoding the video (AVI mode)
66 # an optimal setting for this should be the number of cores you have times 2
67 # note: you have to have an mplayer version that has been compiled with multi thread support.
68 # if you don't, this will have no effect, but won't hurt anything to have it set otherwise.
69 mencoder_threads=8
70
71 ###############################################
72 # Command line processing
73 typeset dvdname=""
74 typeset debug=""
75 typeset dest=""
76 typeset isofile=""
77 typeset vobfile=""
78 typeset dvdpath=""
79 typeset -i keep_intermediate_files=0
80 typeset -i make_final_dest_vob=0
81 typeset -i make_final_dest_iso=0
82 typeset -i make_final_dest_folder=0
83 typeset -i make_final_dest_avi=0
84 typeset -i errors=0
85 typeset -i show_usage=0
86 typeset -i mirror_mode=0
87 typeset -i target_bitrate=0
88 typeset -i target_size=0
89 typeset -i audio_2ch=0
90 typeset -i invalid_feature_title=0
91 typeset -i feature_title_override=0
92 typeset -i mplayer_dumpstream_incompatibility=0
93
94 while (($#)) && getopts 2mvifkxht:n:d:b:s:t: opt "$@"
95 do
96     case $opt in
97         (n)     dvdname=$OPTARG;;
98         (d)     dest=$OPTARG;;
99         (b)     target_bitrate=$OPTARG;;
100         (s)     target_size=$OPTARG;;
101         (2)     audio_2ch=1;;
102         (v)     make_final_dest_vob=1;;
103         (i)     make_final_dest_iso=1;;
104         (f)     make_final_dest_folder=1;; 
105         (x)     make_final_dest_avi=1;;
106         (m)     mirror_mode=1;;
107         (k)     keep_intermediate_files=1;;
108         (t)     feature_title_override=$OPTARG;;
109         (w)     set -$opt;;
110         (h)     show_usage=1;;
111         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
112         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
113     esac
114 done
115
116 shift $((OPTIND-1))
117
118 function usage() {
119     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
120     echo >&2 "Revision $REV"
121     echo >&2 "Options:"
122     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
123     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
124     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
125     echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
126     echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
127     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
128     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
129     echo >&2 "                 The default operation is non-mirror mode where only the main"
130     echo >&2 "                 feature title will be ripped."
131     echo >&2 "   -v            Make the final image a DVD VOB file"
132     echo >&2 "   -i            Make the final image a DVD ISO file"
133     echo >&2 "   -f            Make the final image a DVD folder"
134     echo >&2 "   -x            Make the final image an AVI (XVID) file"
135     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
136     echo >&2 "   -s <size>     Set the target size of the AVI file in MB (ex: 700, 1000, etc)"
137     echo >&2 "   -b <bitrate>  Set the bitrate desired in the AVI file in kbits/sec (ex: 1500, 2000 (default), etc)"    
138     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making an AVI file (default is 6 channel AC3)"
139     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
140     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
141     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
142     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
143     echo >&2 "   -w            Set the sh Execute/Verbose flag"
144     echo >&2 ""
145     exit 2
146 }
147
148 if (($errors)) || (($show_usage))
149 then
150   usage
151 fi
152
153 # Sanity Check - Command Line Options 
154 if [ "$dest" == "" ]; then
155   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
156   usage
157 fi
158
159 if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ]) && [ $make_final_dest_avi -ne 1 ]; then
160   echo "-E- You can't specify a bitrate in non AVI file mode. You must specify '-x' when using '-b' or '-s'" | tee -a $logfile
161   usage
162 fi
163
164 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_avi -eq 1 ]; then
165   echo "-E- You must specify a bitrate in AVI file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
166   usage
167 fi
168
169 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
170    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_avi -eq 0 ] && [ $mirror_mode -eq 0 ]; then
171   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
172   usage
173 fi
174
175 if [ $mirror_mode -eq 1 ]; then
176   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
177      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
178     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
179     usage
180   fi
181 fi
182
183 # Sanity Check - Key executables
184 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
185 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
186 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
187 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
188 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
189 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
190 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
191 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
192
193 ###############################################
194
195 typeset -i ripdvd
196 if [ -z "$dvdname" ]; then
197   # make sure the DVD device is accessible
198   volname $dev > /dev/null 2>&1
199   if [ $? != 0 ]; then
200     echo "-E- Can't access the DVD device $dev"
201     exit 1
202   fi
203   # now capture the volume name from the device
204   dvdname=`volname $dev | awk '{ print $1 }'`
205   ripdvd=1
206 else 
207   # check to see if dvdname is a full path to a real directory
208   # if it is, set dvdname and dvdpath appropriately
209   if [ -d "$dvdname" ]; then
210     dvdpath="$dvdname"
211     dvdname=`basename "$dvdname"`
212     if [ -z "$dvdname" ]; then
213      echo "-E- Unable to extract dvdname from path: $dvdpath"
214      exit 1
215     fi
216     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
217       echo "-E- You must supply a full path to a valid DVD folder with this option"
218       exit 1
219     fi
220   fi
221   # check to see if dvdname is a full path to an MPG2 (VOB) file
222   # if it is, set dvdname and vobfile appropriately
223   if [ -f "$dvdname" ]; then
224     vobfile="$dvdname"
225     dvdname=`basename "$dvdname"`
226     file "$vobfile" | grep -q "MPEG"
227     if [ $? == 0 ]; then
228       # It is a valid MPEG2 file, now strip the extension off our dvdname
229       dvdname=${dvdname%.[^.]*}
230     else 
231       echo "-E- Unsupported file type: $vobfile"
232       exit 1
233     fi
234   fi
235   ripdvd=0
236 fi
237
238 # Make sure we have a non-empty dvdname
239 if [ -z "$dvdname" ]; then
240   echo "-E- unable to determine dvdname"
241   exit 1
242 fi
243
244 # make sure our vobfile value is set
245 if [ -z "$vobfile" ]; then
246   vobfile="$dest/$dvdname.VOB"
247 fi
248
249 # make a "safe" dvdname (remove special characters)
250 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
251
252 # set up some variables to hold various logfiles
253 logfile="$logdir/$dvdname.log"
254 passlogfile="$tmpdir/$safedvdname.log"
255 ddrescuelog=`tempfile`
256 dvdauthorlog=`tempfile`
257 encodelog=`tempfile`
258 dumplog=`tempfile`
259
260 # create the tmpdir if it doesn't already exist
261 if [ ! -d "$tmpdir" ]; then
262   mkdir -p "$tmpdir"
263   if [ $? != 0 ]; then
264     echo "-E- Unable to create the tmpdir: $tmpdir"
265     exit 1
266   fi
267 fi
268
269 # create the logdir if it doesn't already exist
270 if [ ! -d "$logdir" ]; then
271   mkdir -p "$logdir"
272   if [ $? != 0 ]; then
273     echo "-E- Unable to create the logdir: $logdir"
274     exit 1
275   fi
276 fi
277
278 ###############################################
279 # cleanup functions
280 cleanup() { 
281   if [ $keep_intermediate_files -eq 0 ]; then
282     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
283     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
284     [[ -e "$encodelog" ]] && rm -f "$encodelog"
285     [[ -e "$dumplog" ]] && rm -f "$dumplog"
286   else
287     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
288     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
289     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
290     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
291   fi
292   echo ""
293 }
294
295 fatal_and_exit() {
296   if [[ -z "$1" ]]; then
297     msg="-E- control-c killed us"
298   else
299     msg=$1
300   fi
301   echo -e 2>&1 "$msg" | tee -a "$logfile"
302   if [[ -n "$mailto" ]]; then
303     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
304   fi
305   exit 1
306 }
307
308 # Call our cleanup functions on INT and EXIT signals
309 trap fatal_and_exit INT
310 trap cleanup EXIT
311
312 ###############################################
313 # processing functions
314 function make_dvd_iso_image {
315
316   isofile="$1"
317
318   # check to see if we have a dvdpath to rip from instead of $dev
319   if [ -z "$dvdpath" ]; then
320     # load the CSS codes in the DVD drive 
321     lsdvd $dev >> "$logfile"
322     if [ $? != 0 ]; then
323       fatal_and_exit "-E- lsdvd $dev failed" 
324     fi
325
326     # read the DVD, ignoring/skipping CRC errors
327     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
328     if [ $? != 0 ]; then
329       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
330     fi
331     cat "$ddrescuelog" >> "$logfile"
332   else
333     # rip from a path instead
334     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
335   fi
336 }
337
338 function make_dvd_iso_image_from_folder {
339   
340   src="$1"
341   dst="$2"
342   handle_error=$3
343   
344   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
345
346   # make an iso image out of our directory
347   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
348   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
349
350   # set the audio languages from the iso if it exists and is non-zero in size
351   if [ -s "$dst" ]; then
352     get_feature_title "$dst"
353     get_audio_id_from_iso "$dst"
354   fi
355
356   # make sure we were able to create the iso image from the folder given to us
357   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
358     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
359     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
360     # remove the bad iso file
361     [[ -e "$dst" ]] && rm -f "$dst"
362     # get the feature title from the DVD folder
363     get_feature_title "$dvdpath"
364     # create our main VOB file from the ISO
365     create_main_vob_with_mplayer "$dvdpath" 
366     # get our audio id from the VOB file
367     get_audio_id_from_vob "$vobfile"
368   fi
369 }
370
371 function make_dvdbackup_folder_image {
372   # extract the feature title from the DVD image
373   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
374   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
375   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
376   if [ $? != 0 ]; then
377     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
378   fi
379 }
380
381 function make_dvdauthor_folder_image {
382   # create a new DVD video of the feature title
383   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
384   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
385   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
386   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
387
388   # There is a chance that dvdauthor won't like some of the VOBs.
389   # We can't tell ahead of time which ones it will choke on. 
390   # So, we need to run it over and over again until it can process
391   # all the VOBs. If it can't handle one of them, run it through
392   # mencoder to fix it and try again. These errors are typically
393   # present due to the copy protection that ddrescue removed.
394   grep -q "SCR moves" $dvdauthorlog
395   while [ $? == 0 ]; do
396     # fix bad vobs that get the "SCR moves backwards" error:
397     #  STAT: Processing VTS_01_0.VOB...
398     #  ERR:  SCR moves backwards, remultiplex input.
399     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
400     if [[ ! -f "$badvob" ]]; then
401       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
402     fi
403     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
404     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
405     mv -f $badvob.fixed $badvob
406     echo "-> Creating DVD video $dest/$dvdname"
407     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
408     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
409     grep -q "SCR moves" $dvdauthorlog
410   done
411 }
412
413 function get_feature_title {
414   source="$1"
415   # if a feature title was given on the command line, use it
416   if [ $feature_title_override -ne 0 ]; then
417     feature_title=$feature_title_override
418     return 0
419   fi
420   # otherwise, use lsdvd to figure it out
421   if [ $ripdvd -eq 1 ]; then
422     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
423   else 
424     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
425   fi
426 }
427
428 function create_main_vob_with_cat {
429   # cd to the feature title DVD folder
430   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
431   if [ $? != 0 ]; then
432     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
433   fi
434
435   # concatenate all the VOBs together into 1 giant VOB
436   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
437   cat $vobs > "$tmpdir/$dvdname.VOB"
438
439   # cd back to the dir we started from
440   popd > /dev/null 2>&1
441 }
442
443 function create_main_vob_with_mplayer {
444
445   # argument processing  
446   source="$1"
447   remove_dumplog=$2
448
449   # make sure we have a valid feature title
450   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
451     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
452   fi
453
454   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
455   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
456     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
457     msg="$msg We also detected another condition that requires us to use dumpstream. "
458     msg="$msg\n    Unable to rip this DVD in the mode you requested."
459     fatal_and_exit "$msg"
460   fi
461
462   # use mplayer to create the main VOB file
463   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
464   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
465   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
466   if [ $? != 0 ]; then
467     cat $dumplog | grep -v "^A:" >> "$logfile"
468     fatal_and_exit "-E- Mplayer Failed"
469   fi
470   cat $dumplog | grep -v "^A:" >> "$logfile"
471   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
472 }
473
474 function get_audio_id_from_iso {
475   # Adjust our audio ID to find the english audio stream
476   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
477   iso="$1"
478   aidcheck=`tempfile`
479   aid=128
480   mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
481   grep -q "aid: $aid" $aidcheck
482   while [ $? == 1 ] && [ $aid -lt 159 ]; do
483     (( aid = aid + 1 ))
484     grep -q "aid: $aid" $aidcheck
485   done
486   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
487   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
488   # mencoder default DVD audio track language selection (english)
489   lang_opts="-aid $aid -alang en"
490 }
491
492 function get_crop_from_iso { 
493   FRAMES=10000
494   echo "-> Detecting black frame border crop value from ISO file"
495   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
496   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
497   [[ -e "md5sums" ]] && rm -f "md5sums"
498   CROP=`cat $dumplog | grep CROP | tail -1`
499   echo "   Found crop value of $CROP" >> "$logfile"
500   CROP=${CROP#* crop=}
501   CROP=${CROP%%\).*}
502   typeset -i CROPCHECK
503   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
504   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
505   if [ -z "$CROP" ]; then
506     fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
507   fi
508   if [ $CROPCHECK -lt 0 ]; then 
509     CROP=""
510   else 
511     CROP=",crop=$CROP"
512   fi
513   echo "   Setting mencoder crop filter to: $CROP"
514 }
515
516 function get_audio_id_from_vob {
517   # Adjust our audio ID to find the english audio stream
518   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
519   vob="$1"
520   aidcheck=`tempfile`
521   aid=128
522   mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
523   grep -q "Found audio stream: $aid" $aidcheck
524   while [ $? == 1 ] && [ $aid -lt 159 ]; do
525     (( aid = aid + 1 ))
526     grep -q "Found audio stream: $aid" $aidcheck
527   done
528   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
529   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
530   # mencoder default DVD audio track language selection (english)
531   lang_opts="-aid $aid -alang en"
532 }
533
534 function check_vob_for_corrupted_start {
535   # check to see if the beginning of the DVD has a form of copy protection
536   # where they have deliberately broken the first X number of frames of the DVD.
537   # If we don't skip these, our resulting VOB file will not play.
538   badvobcheck=`tempfile`
539   endpos=360
540   skip=0
541   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
542   if [ $? != 0 ]; then
543     fatal_and_exit "-E- Mencoder Failed"
544   fi
545   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
546   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
547     (( skip = skip + 5 ))
548     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
549     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
550     if [ $? != 0 ]; then
551       fatal_and_exit "-E- Mencoder Failed"
552     fi
553     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
554   done
555   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
556
557   # cat the giant VOB into mencoder to create a playable VOB file
558   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
559   if [ $? != 0 ]; then
560     fatal_and_exit "-E- Mencoder Failed"
561   fi
562 }
563
564 function check_vob_for_completeness {
565   # check to make sure we got out a complete VOB.
566   # there is another kind of copy protection where the VOB's may
567   # have "MPG EOF" frames in the middle of the stream. 
568   # this causes mencoder to not process the entire VOB, and exit without any errors.
569   # detect this by seeing how much smaller the dst vob is from the src vob.
570   MAX_FILESIZE_DELTA_PERCENT=70
571   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
572   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
573   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
574   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
575     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
576     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
577     create_main_vob_with_mplayer "$isofile"
578     [[ -e "$dumplog" ]] && rm -f $dumplog
579     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
580     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
581     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
582       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
583     fi
584   fi
585 }
586
587 function check_vob_for_too_many_video_packets {
588   # If our earlier algorithm to work around this failed, throw an error.
589   # check to see if this DVD has a protection scheme we don't know how to work around
590   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
591   # for some reason, the video is black, while the audio rolls, then the video finally comes
592   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
593   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
594   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
595   grep -q "Too many video packets in the buffer:" "$logfile"
596   if [ $? == 0 ]; then
597     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
598     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
599     create_main_vob_with_mplayer "$isofile"
600     grep -q "Too many video packets in the buffer:" $dumplog
601     if [ $? == 0 ]; then
602       [[ -e "$dumplog" ]] && rm -f $dumplog
603       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
604     fi
605     [[ -e "$dumplog" ]] && rm -f $dumplog
606   fi
607 }
608
609 function check_vob_for_a52_crc_errors {
610   # Let's see if we can playback our newly created VOB file without any errors.
611   # if there are issues, let's detect them now, and try to recreate the VOB
612   # there are some forms of copy protection that have missed above, that evidence
613   # themselves when we try to playback the VOB file. This was added to deal with
614   # the "a52: CRC check failed" copy protection scheme.
615   MAX_ERRORS=10
616   ENDPOS=120
617   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
618   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
619   cat $dumplog | grep -v "^A:" >> "$logfile"
620   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
621   if [ $errors -gt $MAX_ERRORS ]; then
622     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
623     create_main_vob_with_mplayer "$isofile"
624     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
625     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
626     if [ $? != 0 ]; then
627       cat $dumplog | grep -v "^A:" >> "$logfile"
628       fatal_and_exit "-E- Mplayer Failed"
629     fi
630     cat $dumplog | grep -v "^A:" >> "$logfile"
631     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
632     if [ $errors -gt $MAX_ERRORS ]; then
633       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
634     fi
635   fi
636   [[ -e "$dumplog" ]] && rm -f $dumplog
637 }
638
639 function calculate_bitrate_from_target_size {
640   # determine what our bitrate needs to be if a target size was specified instead
641   if [ $target_size -ne 0 ]; then
642     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
643     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
644     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
645   fi
646 }
647
648 function create_dvdauthor_dvd_xml_file {
649   # make a dvdauthor xml menu file to create a valid DVD video from 
650   # this script does a good job, but we'll still need to clean it up a bit after it runs
651   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
652   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
653   if [ $? != 0 ]; then
654     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
655   fi
656
657   # replace the first line of the xml file to remove the bad dest path
658   awk -v line=1 -v new_content="<dvdauthor>" '{
659     if (NR == line) {
660       print new_content;
661     } else {
662       print $0;
663     }
664   }' dvd.xml > dvd.xml.new
665   mv -f dvd.xml.new dvd.xml
666   if [ $? != 0 ]; then
667     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
668   fi
669
670   # remove the "<video " property line from the xml file
671   cat dvd.xml | grep -v "<video" > dvd.xml.new
672   mv -f dvd.xml.new dvd.xml
673   if [ $? != 0 ]; then
674     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
675   fi
676   
677   # remove the extra <pgc>..</pgc> pairs
678   cat dvd.xml | awk 'BEGIN {x=1}
679   {
680     if ($0~"</pgc>") {x=0}
681     if (x==1) {print $0}
682     if ($0~"<pgc>") {x=1}
683   }' > dvd.xml.new
684   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
685   mv -f dvd.xml.new dvd.xml
686   if [ $? != 0 ]; then
687     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
688   fi
689
690   # remove the VTS_*_0.VOB file as this is just the main menu video clip
691   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
692   mv -f dvd.xml.new dvd.xml
693   if [ $? != 0 ]; then
694     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
695   fi
696 }
697
698 function check_for_mplayer_dumpstream_incompatibility {
699
700   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
701
702   if [ ! -e "$vobfile" ]; then
703     # mplayer dumpstream does not work on DVDs that obscure the feature title.
704     # A DVD that has 99 titles, where the longest title isn't the main feature
705     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
706     # out what the feature title is. This script will run through that flow if we
707     # set use_mplayer_dumpstream to 0. Check for this here.
708     if [ $ripdvd -eq 1 ]; then
709       lsdvd $dev | grep -q "Title: 99"
710     else
711       lsdvd "$isofile" | grep -q "Title: 99"
712     fi
713     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
714     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
715       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
716         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
717         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
718         invalid_feature_title=1
719       else 
720         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
721         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
722         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
723         use_mplayer_dumpstream=0
724         invalid_feature_title=1
725       fi
726       return
727     fi
728   fi
729
730   # There is another form of protection that causes the mplayer dumpstream to fail. 
731   # This can be detected by telling mplayer to parse the VOB file by copying its audio
732   # video streams to a dummy output file (/dev/null). Do that here to check for that 
733   # problem before continuing.
734   if [ -e "$vobfile" ]; then
735     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
736     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
737     grep -q "Too many audio packets in the buffer" $dumplog
738     if [ $? == 0 ]; then
739       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
740       use_mplayer_dumpstream=0
741       mplayer_dumpstream_incompatibility=1
742     fi
743     [[ -e "$dumplog" ]] && rm -f $dumplog
744   fi
745 }
746
747 function fill_mythvideo_metadata {
748
749   # This function must be passed the filename as an argument
750   # The filename must be a full path to the file
751   filename="$1"
752
753   # Make sure the fill mythvideo metadata option has been set to 1
754   if [ $fill_mythvideo_metadata -eq 0 ]; then
755     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
756     return 0
757   fi
758
759   # If the fill mythvideo metadata script is present, run it
760   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
761   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
762     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
763     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
764   else
765     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
766     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
767   fi
768 }
769
770 function remove_intermediate_vob_file {
771   # remove the intermediate VOB file
772   if [ $keep_intermediate_files -eq 0 ]; then
773     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
774   else
775     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
776   fi
777 }
778
779 function remove_intermediate_iso_file {
780   # remove the original DVD image 
781   if [ $keep_intermediate_files -eq 0 ]; then
782     [[ -e "$isofile" ]] && rm "$isofile"
783   else
784     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
785   fi
786 }
787
788 function remove_intermediate_dvdbackup_folder {
789   if [ $keep_intermediate_files -eq 0 ]; then
790     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
791   else
792     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
793   fi
794 }
795
796 ###############################################
797 # MAIN
798
799 # Make a note of when this DVD rip started
800 date=`date`
801 echo -e "\n$date DVD rip started" >> "$logfile"
802
803 # Rip the DVD - Mirror Mode
804 if [ $mirror_mode -eq 1 ]; then
805   echo "-> Ripping DVD $dvdname to $dest"
806
807   # use ddrescue to make an ISO image of the disk
808   make_dvd_iso_image "$dest/$dvdname.iso"
809
810   # add this video data to the mythtv DB
811   fill_mythvideo_metadata "$dest/$dvdname.iso" 
812
813   # eject the disk upon completion
814   eject -T $dev
815
816   date=`date`
817   echo "$date DVD rip completed" | tee -a "$logfile"
818
819   if [[ -n "$mailto" ]]; then
820     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
821   fi
822
823 fi
824
825 # Rip the DVD - Main Title Feature Only
826 if [ $mirror_mode -eq 0 ]; then
827
828   # Rip image from DVD
829   if [ $ripdvd -eq 1 ]; then
830     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
831     # use ddrescue to make an ISO image of the disk
832     make_dvd_iso_image "$tmpdir/$dvdname.iso"
833   fi
834
835   # Rip image from DVD path
836   if [ -n "$dvdpath" ]; then
837     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
838     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
839   fi
840
841   # make sure our isofile value is set
842   if [ -z "$isofile" ]; then
843     isofile="$tmpdir/$dvdname.iso"
844   fi
845      
846   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
847
848     if [ ! -e "$vobfile" ]; then
849       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
850       
851       # get the feature title from the ISO
852       get_feature_title "$isofile"
853  
854       # get the crop value from the ISO
855       get_crop_from_iso
856
857       # check for mplayer dumpstream incompatibilities
858       # if they exist, this method will set this mode to 0.
859       check_for_mplayer_dumpstream_incompatibility
860
861       if [ $use_mplayer_dumpstream -eq 1 ]; then 
862
863         # get our audio id from the ISO file
864         get_audio_id_from_iso "$isofile"
865
866         # create our main VOB file from the ISO
867         create_main_vob_with_mplayer "$isofile"
868      
869         # remove the intermediate VOB file
870         remove_intermediate_vob_file
871
872         # it's possible that our VOB is still corrupted in some manner
873         # check to make sure it is still a good VOB before continuing.
874         check_for_mplayer_dumpstream_incompatibility
875
876       fi
877  
878       if [ $use_mplayer_dumpstream -eq 0 ]; then 
879
880         # use dvdbackup to make a DVD folder of the feature title
881         make_dvdbackup_folder_image
882   
883         # create our main VOB file
884         create_main_vob_with_cat
885
886         # get our audio id from the VOB file
887         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
888   
889         # check for corrupted VOB start
890         check_vob_for_corrupted_start
891  
892         # check to make sure our VOB is complete
893         check_vob_for_completeness
894
895         # check to make sure our VOB doesn't have too many video packets
896         check_vob_for_too_many_video_packets
897
898         # check to make sure our VOB doesn't have a52 crc errors
899         check_vob_for_a52_crc_errors
900
901         # remove the intermediate VOB file
902         remove_intermediate_vob_file
903
904       fi
905
906       # remove the intermediate ISO file
907       remove_intermediate_iso_file
908
909     else
910       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
911     fi
912
913     # transcode the DVD
914     if [ $make_final_dest_avi -eq 1 ]; then
915       echo "-> Encoding the DVD video to an AVI file" | tee -a "$logfile"
916
917       # determine what our bitrate needs to be if a target size was specified instead
918       calculate_bitrate_from_target_size        
919       
920       # There was a lot of experimentation to arrive at these values
921       # These seem to work OK for me. If they don't work for you, feel
922       # free to adjust/change as needed.
923
924       # Edit these as needed to suite your needs
925       mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
926       mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
927       mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP"
928       mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=$mencoder_threads"
929
930       # There are a number of different ways to encode 6 channel audio.
931       # I've loaded 3 different ways into the mencoder_audioch_opts.
932       # It will cycle through them until it finds one that works. 
933       # You can change the order to suit your needs.
934       if [ $audio_2ch -eq 0 ]; then
935
936         # These options produce good 6 channel audio for the internal mythvideo player, but they can't play in Windows.
937         #mencoder_audio_opts="-oac lavc -lavcopts acodec=ac3"
938         #mencoder_audioch_opts[0]="-channels 6 -af channels=6:6:0:5:1:4:2:3:3:2:4:1:5:0"
939
940         # These options produce good 6 channel audio for linux and windows (except the internal mythvideo player)
941         # This option requires playback under linux with mplayer to be done with options: -channels 6 -ac hwac3,hwdts,mad 
942         mencoder_audio_opts="-oac copy"
943
944         # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
945         mencoder_audioch_opts[0]="-channels 6 -af channels=6"
946         mencoder_audioch_opts[1]="-af channels=6"
947         mencoder_audioch_opts[2]=""
948
949      else 
950         # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
951         mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
952         mencoder_audioch_opts[0]=""
953      fi
954
955       # Do not edit this line. $mencoder_video_encoder_opts must be last
956       mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
957       mencoder_retval=0
958
959       for PASS in 1 2 
960       do 
961         # Set some options based on which pass we are in
962         mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
963         [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
964         [ $PASS -eq 1 ] && output_file="/dev/null"
965         [ $PASS -eq 2 ] && output_file="$dest/$dvdname.avi"
966   
967         # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
968         for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
969         do
970           echo -e "   Encoding pass $PASS"
971           echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
972           mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
973           mencoder_retval=$? 
974           grep -q "\[channels\] Invalid" $encodelog
975           if [ $? != 0 ]; then      
976             break;
977           else
978             echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
979           fi
980         done
981         if [ $mencoder_retval != 0 ]; then
982           fatal_and_exit "-E- Unhandled mencoder error"
983         fi
984         # Concatenate the encode log to our main log file, greping out unwanted lines
985         cat $encodelog | grep -v "Pos:" >> "$logfile"
986       done
987
988       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
989         [[ -e "$vobfile" ]] && rm -f "$vobfile";
990         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
991       else
992         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
993         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
994       fi
995     fi
996
997   # add this video data to the mythtv DB
998   [ $make_final_dest_avi -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.avi" 
999   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1000     
1001   else
1002
1003   # use dvdbackup to make a DVD folder of the feature title
1004   make_dvdbackup_folder_image
1005
1006   # cd to the feature title DVD folder
1007   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1008   if [ $? != 0 ]; then
1009     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1010   fi
1011   
1012   # create the dvd.xml file for dvdauthor
1013   create_dvdauthor_dvd_xml_file  
1014
1015   # make the final DVD folder image
1016   make_dvdauthor_folder_image
1017
1018   # add this video data to the mythtv DB
1019   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1020  
1021   # cd back to the dir we started from
1022   popd > /dev/null 2>&1
1023
1024   if [ $make_final_dest_iso -eq 1 ]; then
1025
1026     # make an iso image out of our directory
1027     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1028    
1029     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1030     if [ -s "$dest/$dvdname.iso" ]; then
1031       if [ $make_final_dest_folder -eq 0 ]; then
1032         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1033         # remove the folder of the DVD image now that we have a .iso version of it
1034         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1035       fi
1036     else
1037       # we created an empty iso file, remove it
1038       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1039       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1040       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1041     fi
1042  
1043     # add this video data to the mythtv DB
1044     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1045
1046   fi
1047
1048   fi
1049
1050   # remove the ddrescue DVD ISO image
1051   remove_intermediate_iso_file
1052
1053   # remove the tmp dvdbackup folder of the DVD image
1054   remove_intermediate_dvdbackup_folder
1055
1056   # eject the DVD disk upon completion
1057   [ $ripdvd -eq 1 ] && eject -T $dev
1058
1059   date=`date`
1060   echo "$date DVD rip completed" | tee -a "$logfile"
1061
1062   if [[ -n "$mailto" ]]; then
1063     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1064   fi
1065
1066 fi
1067